#ifndef _BOARD_H_
#define _BOARD_H_

#include <chessmove.h>
//#include <cl_game.h>
#include <chessboard.h>
#include <sys/time.h>

typedef bool (*checkMove_t)( ChessBoard & a,  ChessMove m );
typedef void (*moveEvent_t)( ChessBoard&  a, ChessMove m);


class Board
{
 protected:
  ChessBoard board;
  time_t sec[2];
  moveEvent_t mE;
  checkMove_t cM;
  
 public:
  Board( moveEvent_t me = stdMoveEvent,
	 checkMove_t cm = &Board::stdCheckMove );
  virtual ~Board();
  
  void move( ChessMove move );
  //  bool replayGame( CL_Game game );
  bool setBoard( const ChessBoard& field );
  //  bool setGame( CL_Game game, int ply );
  ChessBoard getField() 
    { return board; }

  void enableSetBoard();
  void drawBoard();

  void setTime( ChessPiece::color_t col, time_t t );
  virtual void showTime( bool on=1 )=0;

  static bool stdCheckMove( ChessBoard& a, ChessMove m );
  static void stdMoveEvent( ChessBoard& a, ChessMove m );

  ChessPiece& at( ChessCoord::coord_t x, ChessCoord::coord_t y )
    { return board.at( x, y ); }
  ChessPiece& at( ChessCoord& c )
    { return board.at( c ); }
      
  
      
  
  // TODO insertInToolbar

 protected:
  virtual void show()=0;
  virtual void drawXY( ChessCoord::coord_t x, ChessCoord::coord_t y, bool accel=1 )=0;
  virtual void close()=0;
};

#endif  
  
  
