#include <tchessboard.h>
#include <tchessframe.h>
#include <tapp.h>

TChessBoard::TChessBoard( moveEvent_t me, checkMove_t cm )
  : Board( me, cm ), frame(0)
{
  show();
}

  
void TChessBoard::show()
{
  if( !frame ) 
    {
      frame =  new TChessFrame( this );
      tapp->insert( frame );
    }
}

void TChessBoard::close()
{
  if( frame )
    tapp->remove( frame );
}

void TChessBoard::drawXY( ChessCoord::coord_t, ChessCoord::coord_t, bool accel )
{
  if( !accel )
    frame->drawView();
}

void TChessBoard::showTime( bool on )
{
  frame->showTime( on );
}



  
  
  
