#include <xchessframe.h>
#include <wx/colour.h>
#include <wx/dcclient.h>
#include <wx/region.h>
#include <wx/dcmemory.h>

#include <string.h>
#include <algo.h>


//#include <cl_chess.h>
//#include <cl_move.h>

#include <chessboard.h>
#include <chessstdfonts.h>

#ifndef TRUETYPE
#include <bitmaps.h>
#endif
#define TRUETYPE
#define __CB_DEBUG__

#include <iostream>

XChessFrame::XChessFrame( Board * board,
			wxFrame * parent, 
			const wxString& title, 
			int xfsize, int yfsize,
			int xsize, int ysize)

  : wxFrame( parent, -1, title, wxDefaultPosition,
	     wxSize((1+xfsize)*xsize+10, (1+yfsize)*ysize+50)),
  xfs(xfsize), yfs(yfsize), xs(xsize), ys(ysize), field(board),
  isDown(0), dIcon(0), dSave(0), 
  bitmaps(ChessStdFonts::fontname[ChessStdFonts::MARK], 40, 
	  new ChessFontmap(ChessStdFonts::fontmap[ChessStdFonts::MAYA]))
{
  CreateStatusBar();
  CreateToolBar();
  SetBackgroundColour(*wxTheColourDatabase->FindColour("WHITE"));

  Show(TRUE);
};


void XChessFrame::OnPaint(wxPaintEvent& )
{
  //  cout << "PaintEvent" << endl;
  // HERE IS NOW AN ERROR!
  /*
  
  wxSize size=GetSize();
  if( size.GetX()-10 != (xfs+1)*xs ||
      size.GetY()-50 != (1+yfs)*ys )
    {
      int 
	nx=size.GetX()-10-xs,
	ny=size.GetY()-50-ys,
	minfs=0;
      for( int i=0; i < BM_JUMP; i++ )
	{
	  int sz=SIZELIST[i];
	  if( sz> minfs && 
	      sz*xs <= nx && 
	      sz*ys <= ny )
	    minfs=sz;
	}
      if( minfs == 0 )
	minfs = 40;
      xfs=yfs=minfs;
      SetSize( (1+xfs)*xs+10, (1+yfs)*ys+50 );
    }
  
  */
  
  wxPaintDC dc(this);
  PrepareDC(dc);
  
  wxMemoryDC tmpDc;

  
  tmpDc.SetPen( wxPen( *wxBLACK, 1, wxSOLID));
      
  int vX, vY, vW, vH, ox=5, oy=5;
  wxRegionIterator upd(GetUpdateRegion());
  bool clean[xs][ys];
  for( int i = 0; i< ys; i++ )
    for( int j = 0; j<xs; j++ )
      clean[j][i]=0;
    
  while ( upd )
    {
      vX=upd.GetX();
      vY=upd.GetY();
      vW=upd.GetW();
      vH=upd.GetH();
      //      cout << "update: " << vX << ", " << vY 
      //	   << ", " << vW << ", " << vH << endl;

      wxBitmap bmp( ((vW/xfs)+1)*xfs+1, ((vH/yfs)+1)*yfs );
      tmpDc.SelectObject( bmp );
      PrepareDC( tmpDc );
      //      tmpDc.SetBackgroundMode( wxTRANSPARENT );
      tmpDc.SetBackground( *wxWHITE_BRUSH );
      tmpDc.Clear();

      bool docopy=0;

      for( int x=(vX-ox)/xfs; x < xs &&  x <= (vW+vX-ox)/xfs+1; x++ )
	for( int y=(vY-oy)/yfs; y < ys && y <= (vH+vY-oy)/yfs+1; y++ )
	  if ( ! clean[x][y] )
	    {
	      updateField( tmpDc, x, y, field->at( x, 7-y ), vX, vY);
	      docopy=1;
	      clean[x][y]=1;
	    }
      //      dc.SetBackgroundMode(wxTRANSPARENT);
      if( docopy )
	dc.Blit( vX, vY, vW, vH, &tmpDc, 0, 0 );

      upd++;
    }
  tmpDc.SelectObject( wxNullBitmap );
  
}


void XChessFrame::updateField( wxDC& dc, ChessCoord::coord_t x, ChessCoord::coord_t y, ChessPiece f,
			      long dcX, long dcY )
{
  int xo=5, yo=5;
      
  if( x%2  ^ y%2)
    dc.SetBrush( wxBrush( wxColour( 0x77, 0xa2,  0x6d), wxSOLID ));
  else
    dc.SetBrush( wxBrush( wxColour( 0xc8, 0xc3, 0x65 ), wxSOLID ));
  dc.DrawRectangle( xo + x*xfs-dcX, yo + y*yfs-dcY, xfs+1, yfs+1 );  
  
  if( f.piece != ChessPiece::EMPTY )
    /* #ifndef TRUETYPE */
    dc.DrawBitmap( *bitmaps.getBitmap( f ), 
		 xo+x*xfs+1-dcX, yo+y*yfs+1-dcY, TRUE );
  /* #else 
  dc.SetFont(chessfont);
  char s[2];
  cur=f;
  s[0]=cur.toChar();
  s[1]=0;
  cout << "s=" << s << endl;
  dc.DrawText( s,  xo+x*xfs+1-dcX, yo+y*yfs+1-dcY );
  #endif */
  /* cd.Blit(xo+x*xfs+1-dcX, yo+y*yfs+1-dcY
  
	    wxMemoryDC memDC;
	      wxIcon *pieceMap=getBitmap( f, xfs );
  memDC.SelectObject(* pieceMap);

    dc.Blit( 

	  xo+x*xfs+1-dcX,  yo+y*yfs+1-dcY, 
	   xfs-1, 
	   yfs-1, & memDC,
	   0, 0, wxCOPY, TRUE);
	   memDC.SelectObject(wxNullBitmap); 
  dc.DrawBitmap(  *pieceMap, xo+x*xfs+1-dcX,  yo+y*yfs+1-dcY ); */
}

void XChessFrame::OnSize(wxSizeEvent& e)
{
  //  cout << "OnSize" << endl;
  
  wxSize s=e.GetSize();
  int 
    nx=s.GetX()-10-xs, ny=s.GetY()-50-ys,
    minfs=0;

  /*  
  for( int i=0; i < BM_JUMP; i++ )
    {
      int size=SIZELIST[i];
      if( size> minfs && 
	  size*xs <= nx && 
	  size*ys <= ny )
	minfs=size;
    }
  if( minfs == 0 )
    minfs = 40;
  xfs=yfs=minfs;
  
  e=wxSizeEvent( wxSize( (1+xfs)*xs+10, (1+yfs)*ys+50 ));
  */
}

/*
void ChessFrame::DoSetSize(int x, int y,
			   int width, int height,
			   int sizeFlags )
{
  cout << "setsize" << endl;
  
  //  wxFrame::DoSetSize( x, y, (1+xfs)*xs+10, (1+yfs)*ys+50, sizeFlags );
}

*/


void XChessFrame::OnErase( wxEraseEvent& e )
{
  // 
  //  cout << "erase" << endl;
  e.m_dc=0;
  e.Skip();
}

void XChessFrame::OnLeftDown( wxMouseEvent& e )
{
  dx=(e.GetX()-5)/xfs;
  dy=(e.GetY()-5)/yfs;
  ChessPiece f=field->at(dx,7-dy);
  if( f.piece != ChessPiece::EMPTY )
    {
      isDown=1;
      /*#ifndef TRUETYPE */
      dIcon=bitmaps.getBitmap( f );
      /*#else
      //      dIcon = new wxBitmap(xfs, yfs);
      #endif */
      cur.piece=f.piece;
      wxClientDC dc(this);

      PrepareDC(dc);
      updateField( dc, dx, dy, ChessPiece(ChessPiece::EMPTY, ChessPiece::NOCOLOR));  

      dox=e.GetX()-xfs/2;
      doy=e.GetY()-yfs/2;

      dSave=new wxBitmap(xfs, yfs);
      wxMemoryDC saveRec;
      saveRec.SelectObject( *dSave );
      saveRec.Blit( 0, 0, xfs, yfs,  &dc, dox, doy );
      wxMemoryDC cpBMP;
      /*#ifdef TRUETYPE
      cpBMP.SelectObject(*new wxBitmap(xfs, yfs));
      cpBMP.SetFont(chessfont);
      char s[2];
      s[1]=0;
      s[0]=f.toChar();

      cpBMP.SetBackground(*wxTRANSPARENT_BRUSH);
      cpBMP.Clear();
      cpBMP.DrawText( s, 0, 0 );
      #else */
      cpBMP.SelectObject( *dIcon );
      dc.Blit( dox, doy, dIcon->GetWidth(), dIcon->GetHeight(), 
	       &cpBMP, 0, 0, wxCOPY, TRUE );
      /* #endif */
      dc.Blit( dox, doy,  xfs, yfs, 
	       &cpBMP, 0, 0, wxCOPY, TRUE );

      cpBMP.SelectObject(wxNullBitmap);
      
      //dc.DrawIcon( *dIcon, dox, doy );
      
    }
    
  //  cout << "Left down" << endl;
  
  wxClientDC dc(this);
  

  
}


void XChessFrame::OnLeftUp( wxMouseEvent& e )
{
  int 
    nx=(e.GetX()-5)/xfs,
    ny=(e.GetY()-5)/yfs;
  //  cout << "dx=" << dx << "dy=" << dy << "nx=" << nx << "ny=" << ny << endl;
  if( ChessCoord::isInBoard( nx, ny ) &&
      field->at( dx, 7-dy ) != ChessPiece::EMPTY &&
      (dx != nx || dy != ny ))
    field->move( ChessMove ( dx, 7-dy, nx, 7-ny ) );
  
  Refresh(FALSE);
  //  cout << "Left up" << endl;
  isDown=0;
  delete dSave;
  dSave=0;
}


void XChessFrame::OnMotion(wxMouseEvent& e )
{

  
  if( isDown )
    {
      wxClientDC dc(this);

      
      long
	nx=e.GetX()-xfs/2,
	ny=e.GetY()-yfs/2,
	minX = min( nx, dox ),
	maxX = max( nx+xfs, dox+xfs ),
	minY = min( ny, doy ),
	maxY = max( ny+xfs, doy+xfs ),
	xlen = maxX - minX,
	ylen = maxY - minY;
      
      wxBitmap bmp( xlen, ylen );
#ifdef __CB_DEBUG__
      //      cout << "minX=" << minX << ", maxX= " << maxX << endl;
      //      cout << "xlen=" << xlen << ", ylen= " << ylen << endl;
#endif
      

      wxMemoryDC saveRec, doubleDc;
      doubleDc.SelectObject( bmp );
      //      doubleDc.SetDeviceOrigin( -minX, -minY );
      doubleDc.Blit( 0, 0, xlen, ylen, &dc, minX, minY );
      dc.Blit( minX, minY, xlen, ylen, &doubleDc, 0, 0 );
      
      doubleDc.DrawBitmap( *dSave, dox-minX, doy-minY );
      
      saveRec.SelectObject( *dSave );
      saveRec.Blit( 0, 0, xfs, yfs,  &doubleDc, nx-minX, ny-minY );

      //      wxMemoryDC cpBMP;
      //      cpBMP.SelectObject( *dIcon );
      // 
      //	     dIcon->GetHeight(), &cpBMP, 0, 0, TRUE);
  //      cpBMP.SelectObject(wxNullBitmap);



      //      cout << "ifdef" << endl;
      /* #ifndef TRUETYPE */
      //      cout << "ntruetype" << endl;
      doubleDc.DrawBitmap( *dIcon, nx-minX, ny-minY, TRUE );
      /* #else 
      doubleDc.SetFont(chessfont);
      char s[2];
      s[0]=field->at(dx,dy).toChar();
      //      s[0] = 'r';
      s[1]=0;
      cout << "s2=" << s << ", " << cur.piece << endl;
       
      //      doubleDc.Clear();
      
      doubleDc.DrawText(s, nx-minX, ny-minY );
      #endif */
      dc.Blit( minX, minY, xlen, ylen, &doubleDc, 0, 0 );
      dox=nx;
      doy=ny;
    }
}

void XChessFrame::drawXY( ChessCoord::coord_t x, ChessCoord::coord_t y )
{
  wxClientDC dc(this);
  wxMemoryDC memDC;
  wxBitmap bmp( xfs+1, yfs+1 );
  memDC.SelectObject( bmp );
  //  updateField( memDC, 0, 0, field->at( x, y ));
  //  dc.Blit( x, y, xfs+1, yfs+1, &memDC, 0, 0 );
  memDC.SelectObject( wxNullBitmap );
}

void XChessFrame::setBoard(const ChessBoard&)
{
}

BEGIN_EVENT_TABLE(XChessFrame, wxFrame)
  EVT_PAINT(XChessFrame::OnPaint)
  //  EVT_ERASE_BACKGROUND(XChessFrame::OnErase)
  EVT_LEFT_DOWN(XChessFrame::OnLeftDown)
  EVT_LEFT_UP(XChessFrame::OnLeftUp)
  EVT_MOTION(XChessFrame::OnMotion)
END_EVENT_TABLE()
