#ifndef _XCHESSFRAME_H_
#define _XCHESSFRAME_H_

#include <wx/frame.h>
//#include <cl_chess.h>
#include <chessboard.h>
#include <chesspiece.h>
#include <wx/font.h>
#include <board.h>

//#define TRUETYPE
#include <chesswxbitmap.h>


class wxBitmap;



class XChessFrame : public wxFrame
{
  int xfs, yfs, xs, ys;
  Board *field;
  ChessPiece cur;

  // dnd information
  bool isDown;
  int dx, dy;
  long dox, doy;
  wxBitmap* dIcon;
  wxBitmap* dSave;
  ChessWxBitmap  bitmaps;
  
 public:
  XChessFrame( Board * field,
	      wxFrame * parent=0, 
	      const wxString& title="Board",
	      int xfsize=64, int yfsize=64,
	      int xsize=Chess::XSIZE, int ysize=Chess::YSIZE);
  void OnPaint( wxPaintEvent& );
  void OnSize( wxSizeEvent& e );
  void OnErase( wxEraseEvent& );
  void OnLeftDown( wxMouseEvent& e);
  void OnLeftUp( wxMouseEvent& e);
  void OnMotion( wxMouseEvent& e);
  
  void setBoard( const ChessBoard& board );
  
  /*  void DoSetSize( int x, int y,
		  int width, int height,
		  int sizeFlags = wxSIZE_AUTO ); */
  void updateField( wxDC& dc, 
		    ChessCoord::coord_t x, ChessCoord::coord_t y , ChessPiece f,
		    long dcX = 0, long dcY = 0);
  void drawXY( ChessCoord::coord_t x, ChessCoord::coord_t y );

  

  DECLARE_EVENT_TABLE()
};

#endif
