#ifndef __CHESSGICSPARSE_HH__
#define __CHESSGICSPARSE_HH__

#include <parser.h>
#include <string.h>

#include <pthread.h>

class ChessGicsParse : public Parser<string>
{
  pthread_t th;
public:
  ChessGicsParse();
  ChessGicsParse(const char * server, 
		 int port = 5000);
  void run();
  void send(const char *s) const 
    { write( in, s, strlen(s)); }
  void send(string s) const 
    { write( in, s.c_str(), s.size()); }
  void sendLn(string s) const
    { send(s + "\n"); }

  virtual void evIntro( const string s ) { echo(s); }
  virtual void evMisc( const string s ) { echo(s); }
  virtual void evQuit( const string s ) { echo("\n"); echo(s); }
  virtual void evPrompt( const string s ) { echo(s); }
  virtual void evIt(const string s ) { echo(s); }
  virtual void evShout(const string s ) { echo(s); }
  virtual void evPosition( const string s ) { echo(s); }
  virtual void evLogin( const string s ) { echo(s); }
  
  virtual void echo( const string s )
    { cout << s << flush; }

  static void* inputThread(void* in);
  void startStdinThread();
  void waitThread();
  

    
 private:
  void restline();
};

#endif
