#include <chessgicsparse.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <string>
#include <fstream>

#include <alloc.h>

#include <errno.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <netdb.h>

#include <readline/readline.h>
#include <stdio.h>
#include <readline/history.h>




/* extern ChessGicsYYType  Clval; */

void ChessGicsParse::run()
{
  int eoIntro=0;
  int nextId;
run:

/*!re2c
      any = [\000-\377];
      newline = [\n];
      dot = (any\newline);
*/
 
intro:
/*!re2c
  ("Server location:" dot* "\n") { yyval+=getToken(); 
                                   evIntro(yyval);
				   yyval="";
                                   goto newtalk;}
  any                            { 
                                  if( eof ) return;
                                  else yyval+=(char)*(cursor-1);
				  tok=cursor;
				  goto intro; }
*/
 newtalk:
  if( *cursor == '\r' )
    { cursor++;  }
  
  /*!re2c
    "<12>" { tok++; 
              restline();   
              evPosition( yyval ); 
	      yyval="";
              goto newtalk; }
    (dot* "%")      { evPrompt(getToken());
                      goto talk; }
  "login:" { tok++; evLogin( getToken() ); goto talk; }

  "-->"           { tok=cursor+1; 
                    restline();
	            evIt( yyval ); 
                    goto newtalk; }
  ([a-zA-Z]* " shouts:") { restline();
                           evShout( yyval );
                           goto newtalk; }
  ("(" [0-9]+ ") " [a-zA-Z]* " shouts:") { tok+=4;
                         restline();
	                 evShout( yyval );
                         goto newtalk; }
  ([\r]* " "* ".::.") { yyval=""; cout << "quit" << endl;  goto quit; } 
   any            { // cout << "any=" << int(*(cursor-1))  << "(" << (char) *(cursor-1) << ")" << endl; 
   assert(cursor != bot ); cursor--; goto talk; }
  */

 talk:
/*!re2c


  (dot* "\n") { 
                 nextLine();
                 if( cursor-bot >= 2 && *(cursor-2) == '\\'  )
                   yyval+=getToken();
                 else
                   {
                     yyval+=getToken();
		     evMisc( yyval );
                     yyval="";
                   }
                  if( !eof ) goto newtalk;
		  else { yyval=""; goto quit; }
		}

 */

 quit:
  /*!re2c
    (dot* "\n") {   yyval+=getToken(); 
                  if( !eof || lim > cursor ) goto quit; 
                  else { yyval+=getToken(); 
                       evQuit(yyval); } }
  */
  rl_cleanup_after_signal();
}

void ChessGicsParse::restline()
{
  yyval=getToken();
 restline:
   /*!re2c
	    (dot* "\n") { yyval+=getToken();
	                  nextLine();
                          if( (cursor-bot) >= 2 || *(cursor-2) != '\\' )
			     return;  
                          else 
                           goto restline;}
   */
}

ChessGicsParse::ChessGicsParse()
	: Parser<string>( open("test.par", O_RDONLY), 153 )
{
}

ChessGicsParse::ChessGicsParse( const char * server, 
				int port )
  : Parser<string>( 0, 153 )
{
  // TODO: throw execptions!!
  struct hostent *he=gethostbyname(server);
  struct sockaddr_in server_addr;
  if( !he )
    {
      cerr << "server unknown." << endl;
      exit(1);
    }
  if( (in = socket( AF_INET, SOCK_STREAM, 0 )) == -1 )
    {
      cerr << "socket error." << endl;
      exit(1);
    }
  server_addr.sin_family = AF_INET;
  server_addr.sin_port = htons( port );
  server_addr.sin_addr = *((struct in_addr *)he->h_addr);
  
  if( connect( in, (struct sockaddr* ) &server_addr,
	       sizeof(struct sockaddr) ) == -1 )
    {
      cerr << "cannot connect." << endl;
      exit(1);
    }
  cout << "connected" << endl;
  
}


void pr(const char *s)
{
  cout << "s=" << s << endl;
}

void* ChessGicsParse::inputThread(void* in)
{
  char *s;
  ofstream out(*(int*)in);
  while( (s = readline("")) != 0 )
    {
      out << s << endl;
      if( *s )
	add_history(s);
      free(s);
    }
  exit(0);
}

void ChessGicsParse::startStdinThread()
{
  pthread_create( &th, 0, inputThread, (void*)&in);
}

void ChessGicsParse::waitThread()
{
  pthread_join( th, 0 );
}





/* end of file */
