#include <chesspiece.h>
#include <ctype.h>
#include <assert.h>

#ifndef NDEBUG
#include <string.h>
#include <iostream.h>
#endif


char * ChessPiece::pieceCharTab = " KQRBNP";
char * ChessPiece::nameTab[] = {
  "",
  "King",
  "Queen",
  "Rook",
  "Bishop",
  "Knight",
  "Pawn" 
};
 

ChessPiece::ChessPiece(char c)
{

  assert(isPieceChar(c));
  
  color = isupper(c) ? WHITE : BLACK;
  c=toupper(c);
  for( int i=EMPTY; i<=PAWN; i++)
    if( pieceCharTab[i] ==  c )
      {
	piece=piece_t(i);
	return;
      }
  piece=EMPTY;
}

bool ChessPiece::isPieceChar(char c)
{
  c=toupper(c);
  for( int i=ChessPiece::EMPTY; i <= ChessPiece::PAWN; i++)
    if( pieceCharTab[i] == c )
      return 1;
  if( c == '-' )
    return 1;
  return 0;
}

void ChessPiece::setPieceCharTab(char * tab)
{
  pieceCharTab=tab;
}

char ChessPiece::toChar() const
{
  assert(strlen(pieceCharTab) > unsigned (piece));
  return color == WHITE ? pieceCharTab[piece] : tolower(pieceCharTab[piece]);
}

const char * ChessPiece::toName() const
{
  assert( piece != EMPTY );
  return nameTab[piece];
}

  
  




  
  
  
