#include <chesspiececoordtab.h>

ChessPieceCoordTab::undoErase_t 
ChessPieceCoordTab::erase( ChessPieceCoordTab::iterator it )
{
  ChessPiece::color_t col=
    it >= tab+MAXSIZE ? ChessPiece::BLACK : ChessPiece::WHITE;
  undoErase_t undo(*it, col); 
  *it =  col == ChessPiece::BLACK ?
    tab[MAXSIZE + --size[1]] :
    tab[--size[0]]; 
  return undo;
}

void ChessPieceCoordTab::undoErase( const ChessPieceCoordTab::undoErase_t & e )
{
  ChessCoord* pos;
  if( e.color == ChessPiece::WHITE )
    pos=tab + size[ChessPiece::WHITE]++;
  else
    pos = tab + MAXSIZE + size[ChessPiece::BLACK]++;
  *pos=e.c;
  boardTab[e.c.getIndex()] = pos;
}

ChessPieceCoordTab::ChessPieceCoordTab( const ChessBoard& b )
{
  size[0]=size[1]=0;
  ChessCoord::coord_t index;
  for( ChessBoard::const_iterator it=b.begin(); it != b.end(); it++ )
    if( ! it->empty() ) 
      {
	index=it-b.begin();
	ChessCoord *t;
	if( it->getColor() == ChessPiece::BLACK )
	  t=tab+MAXSIZE+size[1]++;
	else
	  t=tab+size[0]++;
	*t=index;
	boardTab[index]=t;
      }
  else
    boardTab[index]=0;
}

  
    
