/* file: ChessLib/chessundoboardmove.h
   author: Christoph Bauer
   date: 22.1.00
   license: GPL
   
   ChangeLog:
     o 22.1.00 created
     
   Description:
     Mit dem Konstrukt "ChessUndoMove" kann man Informationen speichern um Zge zurckzunehmen
*/

#ifndef __CHESSUNDOBOARDMOVE_H__
#define __CHESSUNDOBOARDMOVE_H__

#include <chesscoord.h>
#include <chessboardflags.h>

class ChessBoard;

class ChessUndoBoardMove
{
  ChessCoord startField, endField;
  ChessPiece::piece_t endPiece, startPiece;
  ChessBoardFlags flags;
 public:
  ChessUndoBoardMove(ChessCoord startF, ChessPiece::piece_t startP,
		     ChessCoord endF, ChessPiece::piece_t endP,
		     ChessBoardFlags f)
    : startField(startF), endField(endF),
    endPiece(endP), startPiece(startP), flags(f)
    {}
  
  void undo(ChessBoard& board) const;
};


#endif
