//#include "parser.h"
#include <string.h>
#include <iostream.h>
#include <unistd.h>
#include <errno.h>

template<class yyval_t>
Parser<yyval_t>::Parser(int fd, size_t blocksize )
  :in(fd), line(0), word(0), cursor(0),
   lim(0), ptr(0), eof(0), tok(0), bot(0), bsize(blocksize), top(0)
{
}

template<class yyval_t>
Parser<yyval_t>::~Parser()
{
  close(in);
}


template<class yyval_t>
Parser<yyval_t>::uchar * Parser<yyval_t>::fill(Parser<yyval_t>::uchar * c, uint n)
{
  if( !eof ) 
    {
      uint cnt = tok - bot;
      if( cnt ) 
	{
	  memcpy(bot, tok, lim - tok);
	  tok = bot;
	  ptr -= cnt;
	  cursor -= cnt;
	  pos -= cnt;
	  lim -=cnt;
	}
      if( (top - lim) < bsize ) {
	uchar * buf = new uchar[(lim-bot) + bsize];
	memcpy(buf, tok, lim - tok);
	tok = buf;
	ptr = &buf[ptr - bot];
	cursor = &buf[cursor - bot];
	pos = &buf[pos - bot];
	lim = &buf[lim - bot];
  	top = &lim[bsize];
	delete [] bot;
	bot = buf;
      }
      if((cnt = read(in, (char*) lim, n - (lim - cursor)+1)) == 0 ) 
	{
	  eof =  &lim[cnt];
	  *eof++='\n';
	}
      //      cout << "lim=" << (char*)lim << endl;
      //      cout << "errno=" << errno << ", EAGAIN= " << EAGAIN << endl;
      
      //      cout << "cnt=" << cnt << endl;
      lim+= cnt;
      if( lim - cursor < n )
	return fill( cursor, n );
    }
  return cursor;
}

template<class yyval_t>
void Parser<yyval_t>::fatal()
{
  cerr << "line " << getLine() << ": parse error";
  exit(1);
}

  
	
  
  

  
